﻿package {
	
	import flash.display.Stage;
	import flash.text.TextFormat;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.system.LoaderContext;
	import flash.geom.Point;
	import flash.system.System;
	import flash.system.Security;
	import flash.system.SecurityPanel;
	import com.google.maps.Map;
	import com.google.maps.LatLng;
	import com.google.maps.MapMouseEvent;
	import com.google.maps.overlays.Marker;
	import com.google.maps.overlays.MarkerOptions;
	import com.google.maps.InfoWindowOptions;
	
	public class PhotoMarker extends Marker {
		
		public var googleMaps:Map;
		public var baseObj:photoMakerBase;
		public var imgLoader:Loader
		public var title:String;
		public var farm:String;
		public var server:String;
		public var id:String;
		public var secret:String;
		public var owner:String;
		public var ownerName:String;
		public var datetaken:String;
		public var photo:String;
		public var url:String;
		public var imgShowFlag = false;
		
		//コンストラクタ
		public function PhotoMarker(latLng:LatLng, maps:Map) {
			//ベースオブジェクト生成
			baseObj = new photoMakerBase();
			baseObj.baseL.visible = false;
			baseObj.baseL.infoTxt.mouseEnabled = false;
			//Mapオブジェクトを変数へ格納
			googleMaps = maps;
			//スーパークラス呼び出し
			super(latLng, new MarkerOptions( { icon : baseObj } ));
			//マーカークリックイベント
			addEventListener(MapMouseEvent.CLICK, clickHandler);
		}
		
		//画像読込
		public function imgLoad():void {
			//画像URL
			photo = "http://farm" + farm + ".static.flickr.com/" + server + "/" + id + "_" + secret + "_m.jpg";
			//URLLoader作成
			var imgUrl:URLRequest = new URLRequest(photo);
			imgLoader = new Loader();
			//イベント設定
			imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, compImgLoad);
			//読み込み開始
			imgLoader.load(imgUrl, new LoaderContext(true));
		}
		
		//画像読込完了
		public function compImgLoad(event:Event):void {
			//画像サイズ
			setImgSize(30, -35);
			baseObj.addChild(imgLoader);
			//ラージサイズに表示する情報
			baseObj.baseL.infoTxt.htmlText = "<textformat rightmargin='10' leading='1'>";
			baseObj.baseL.infoTxt.htmlText += "<font color='#DD0000'><b>" + title + "</b></font>\n";
			baseObj.baseL.infoTxt.htmlText += "<font color='#666666'>" + ownerName + "</font>\n";
			baseObj.baseL.infoTxt.htmlText += "<font color='#666666'>" + datetaken + "</font>\n";
			//リンクボタンのイベント設定
			url = "http://www.flickr.com/photos/" + owner + "/" + id + "/";
			baseObj.baseL.linkBtn.addEventListener(MouseEvent.CLICK, clickLinkHandler);
		}
		
		//リンククリックイベント
		function clickLinkHandler(event:MouseEvent):void {
			var linkurl:URLRequest = new URLRequest(url);
			navigateToURL(linkurl, "_blank");
		}
		
		//画像サイズ
		public function setImgSize(setSize:Number, divY:Number):void {
			imgLoader.width = setSize;//横に合わせる
			imgLoader.scaleY = imgLoader.scaleX;
			if (imgLoader.height > setSize) {
				imgLoader.height = setSize;//縦に合わせる
				imgLoader.scaleX = imgLoader.scaleY
			}
			imgLoader.x = -imgLoader.width / 2;
			imgLoader.y = -imgLoader.height / 2 + divY;
		}
		
		//マーカークリックイベント
		function clickHandler(event:MapMouseEvent):void {
			//フラグ調整
			imgShowFlag = ! imgShowFlag;
			if (imgShowFlag) {
				//ラージサイズを表示
				baseObj.baseS.visible = false;
				baseObj.baseL.visible = true;
				setImgSize(240, -185);
			} else {
				//スモールサイズを表示
				baseObj.baseS.visible = true;
				baseObj.baseL.visible = false;
				setImgSize(30, -35);
			}
		}
	}
}